/* 
 * @experimental
 *
 * EventHandlers.cs
 * Generated with https://github.com/blueprintui/custom-element-types
 */

using Microsoft.AspNetCore.Components;
using System.Text.Json;

namespace BlazorApp;

[EventHandler("on", typeof(CustomEventArgs))] // 
[EventHandler("oninput", typeof(CustomEventArgs))] // bp-button-sort, bp-color, bp-date, bp-file, bp-input, bp-month, bp-pagination-input, bp-password, bp-range, bp-rating, bp-search, bp-select, bp-switch, bp-textarea, bp-time
[EventHandler("onchange", typeof(CustomEventArgs))] // bp-button-sort, bp-checkbox, bp-color, bp-date, bp-file, bp-input, bp-month, bp-pagination-input, bp-password, bp-radio, bp-range, bp-rating, bp-search, bp-select, bp-switch, bp-textarea, bp-time
[EventHandler("onopen", typeof(CustomEventArgs))] // bp-drawer, bp-nav, bp-nav-group, bp-shell, bp-toast, bp-tooltip
[EventHandler("onclose", typeof(CustomEventArgs))] // bp-drawer, bp-nav, bp-nav-group, bp-shell, bp-toast, bp-tooltip
[EventHandler("onsize", typeof(CustomEventArgs))] // 
[EventHandler("onscroll", typeof(CustomEventArgs))] // 
public static class EventHandlers
{

}

public class CustomEventArgs : EventArgs
{
  public dynamic? Detail { get; set; }

  /* Returns the detail value of CustomEvent with given type */
  public T GetDetail<T>() {
    return JsonSerializer.Deserialize<T>(Detail); // used to cast dynamic type, unknown until event occurs at runtime
  }
}