
/**
 * @experimental
 * 
 * wwwroot/custom-events.js
 * Generated with https://github.com/blueprintui/custom-element-types
 */

const customEvents = {
  : true, // ,
  input: true, // bp-button-sort, bp-color, bp-date, bp-file, bp-input, bp-month, bp-pagination-input, bp-password, bp-range, bp-rating, bp-search, bp-select, bp-switch, bp-textarea, bp-time,
  change: true, // bp-button-sort, bp-checkbox, bp-color, bp-date, bp-file, bp-input, bp-month, bp-pagination-input, bp-password, bp-radio, bp-range, bp-rating, bp-search, bp-select, bp-switch, bp-textarea, bp-time,
  open: true, // bp-drawer, bp-nav, bp-nav-group, bp-shell, bp-toast, bp-tooltip,
  close: true, // bp-drawer, bp-nav, bp-nav-group, bp-shell, bp-toast, bp-tooltip,
  size: true, // ,
  scroll: true, // 
};

/**
 * Workaround: Blazor ignores the event target and only listens to global events
 * this is a problem for most custom elements which dispatch CustomEvent types
 * that default to not bubbling.
 */
CustomEvent = class Bubbled extends CustomEvent {
  constructor(event, config) {
    const bubbles = customEvents[event] !== undefined ? customEvents[event] : config.bubbles;
    super(event, { ...config, bubbles });
  }
}

Object.keys(customEvents).map(event => {
  Blazor.registerCustomEventType(event, {
    browserEventName: event,
    createEventArgs: event => {
      return { detail: event.detail };
    }
  });
});
